package nl.amis.tourdefrance.model;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

@Entity
public class Rider {
    
    // note: more details on rider can be retrieved from:
    // http://www.letour.fr/2010/TDF/RIDERS/us/coureurs/11.html
    // where 11 is the riderNumber
    
    // details include: country, birthdate and place of birth, length, weight (before start??)
//    <h3>TEAM RADIOSHACK (RSH)</h3> 
//            
//            
//            <p class="coureurNom">21 - ARMSTRONG Lance (USA)</p> 
//            <p>Born in 18/09/1971&nbsp;&agrave;&nbsp;Plano-Dallas&nbsp;(USA&#41</p> 
//            <p>Height : 1.77 m
//            <br />Weight : 75 kg</p> 
    

    @Id @GeneratedValue
    private Integer id;

    private String name;
    private int riderNumber;
    private String team;
    
    @ManyToOne(cascade=CascadeType.ALL)
    @JoinColumn(name = "TOUR_ID")
    private Tour tour;
    
    public Rider() {
        
    }

    public Rider(String name, int riderNumber, String team) {
        super();
        this.name = name;
        this.riderNumber = riderNumber;
        this.team = team;
    }

    public void setRiderNumber(int riderNumber) {
        this.riderNumber = riderNumber;
    }

    public int getRiderNumber() {
        return riderNumber;
    }

    public void setTeam(String team) {
        this.team = team;
    }

    public String getTeam() {
        return team;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getName() {
        return name;
    }

    public void setTour(Tour tour) {
        this.tour = tour;
    }

    public Tour getTour() {
        return tour;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public Integer getId() {
        return id;
    }
}
