package nl.amis.tourdefrance.model;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;


@Entity
public class Tour {

    @Id
    @GeneratedValue
    private Integer id;

    @Column(nullable = false)
    Integer year;
    int numberOfStages;
    boolean prologue;
    @Temporal(value = TemporalType.DATE)
    Date startDate;
    @OneToMany(cascade = { CascadeType.PERSIST, CascadeType.MERGE }, mappedBy = "tour")
    List<Stage> stages = new ArrayList<Stage>();

    @OneToMany(cascade = { CascadeType.PERSIST, CascadeType.MERGE }, mappedBy = "tour")
    Map<Integer, Rider> riders = new HashMap<Integer, Rider>();

    public Tour() {

    }

    public Tour(Integer year, int numberOfStages, boolean prologue) {
        super();
        this.year = year;
        this.numberOfStages = numberOfStages;
        this.prologue = prologue;
    }

    public void setYear(Integer year) {
        this.year = year;
    }

    public Integer getYear() {
        return year;
    }

    public void setNumberOfStages(int numberOfStages) {
        this.numberOfStages = numberOfStages;
    }

    public int getNumberOfStages() {
        return numberOfStages;
    }

    public void setPrologue(boolean prologue) {
        this.prologue = prologue;
    }

    public boolean isPrologue() {
        return prologue;
    }

    public void setStartDate(Date startDate) {
        this.startDate = startDate;
    }

    public Date getStartDate() {
        return startDate;
    }

    public void setStages(List<Stage> stages) {
        this.stages = stages;
    }

    public List<Stage> getStages() {
        return stages;
    }

    public void setRiders(Map<Integer, Rider> riders) {
        this.riders = riders;
    }

    public Map<Integer, Rider> getRiders() {
        return riders;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public Integer getId() {
        return id;
    }
}
